<?php
/**
 *                                                                                        
 *               
 * 
 *                                                                
 * 
 *                                                                                       
 *                                                                        
 *                                                                                    
 * 
 *                       
 **/


/**
 *                                   
 **/

define("XNL_O_PRIORITY_AND", 10);
define("XNL_O_PRIORITY_OR", 10);

define("XNL_O_PRIORITY_EQ", 15);
define("XNL_O_PRIORITY_NEQ", 15);
define("XNL_O_PRIORITY_GT", 15);
define("XNL_O_PRIORITY_LT", 15);
define("XNL_O_PRIORITY_GTEQ", 15);
define("XNL_O_PRIORITY_LTEQ", 15);

define("XNL_O_PRIORITY_MOD", 20);
define("XNL_O_PRIORITY_ARITH", 20);

/**
 *                                                                                     
 **/
global $known_operators;
$known_operators = array( new XNL_BinaryAndOperator(), 
new XNL_BinaryOrOperator(),
new XNL_BinaryGtOperator(),
new XNL_BinaryLtOperator(),
new XNL_BinaryGtEqOperator(),
new XNL_BinaryLtEqOperator(),
new XNL_BinaryEqOperator(),
new XNL_BinaryNeqOperator(),
new XNL_BinaryModOperator(),
new XNL_BinaryDivOperator(),
new XNL_BinaryMultOperator(),
new XNL_LeftUnaryNotOperator()
);


/**
 *              
 *
 *                                                     
 *  
 *            
 *            
 *                                                                               
 **/
function xnl_is_operator( $str, &$pos )
{
global $known_operators;
//                                                    
 $foundLen = 0;
$foundOp = null;
foreach ( $known_operators as $op )
{
$opStrs = $op->getOperatorStrings();
foreach ( $opStrs as $opStr )
{
$len = strlen( $opStr );
if ( $len > $foundLen )
{
if ( substr($str, $pos, $len) == $opStr  )
{
$foundLen = $len;
$foundOp = $op;
}
}
}
}
if ( $foundOp !== null )
{
$pos += $foundLen;
return $foundOp;
}
return false;
}



/**
 *                                               
 **/
class XNL_Operator 
{

/**
     *                           
     * 
     *                                                                    
     **/
function getOperatorStrings() {}

};


//                                                                
class XNL_LeftUnaryOperator extends XNL_Operator
{
/**
     *                                      
     * 
     *                                                         
     * 
     *      
     *                                          
     *                                               
     *                     
     * 
     *                 
     *                                                                             
     **/
function performOperation( $operand ){}
};

/**
 *                                 
 **/
class XNL_LeftUnaryNotOperator extends XNL_LeftUnaryOperator
{
function getOperatorStrings()
{
return array( "!" );
}

function performOperation( $operand )
{
if ( $operand )
return 0;
return 1;
}
};


//                                                            
class XNL_BinaryOperator extends XNL_Operator
{
/**
  *                                   
  * 
     *                                                                                 
     * 
     *      
     *                                          
     *                                               
     *                     
     * 
  *                    
  *                     
  *         
  **/
function performOperation( $leftOperand, $rightOperand ){}


/**
     *                              
     * 
     *                                                                                  
     *          
     *                
     * 
     *              
     *              
     * 
     *                                       
     *       
     * 
     *                                                                           
     * 
     *         
     **/
function getPriority() {}
};

class XNL_BinaryAndOperator extends XNL_BinaryOperator
{

function getOperatorStrings() 
{
return array( "&&" );
}

//                                                                        
 
function getPriority()
{
return XNL_O_PRIORITY_AND;
}

function performOperation( $leftOperand, $rightOperand )
{
if ( $leftOperand && $rightOperand )
return 1;
return 0;
}
};

class XNL_BinaryOrOperator extends XNL_BinaryOperator
{
function getOperatorStrings()
{
return array( "||" );
}

function getPriority()
{
return XNL_O_PRIORITY_OR;
}

function performOperation( $leftOperand, $rightOperand )
{
if ( $leftOperand || $rightOperand )
return 1;
return 0;
}
};


class XNL_BinaryLtEqOperator extends XNL_BinaryOperator
{
function getOperatorStrings()
{
return array( "<=" );
}

function getPriority()
{
return XNL_O_PRIORITY_LTEQ;
}

function performOperation( $leftOperand, $rightOperand )
{
if ( $leftOperand <= $rightOperand )
return 1;
return 0;
}
};

class XNL_BinaryLtOperator extends XNL_BinaryOperator
{
function getOperatorStrings()
{
return array( "<" );
}

function getPriority()
{
return XNL_O_PRIORITY_LT;
}

function performOperation( $leftOperand, $rightOperand )
{
if ( $leftOperand < $rightOperand )
return 1;
return 0;
}
};

class XNL_BinaryGtEqOperator extends XNL_BinaryOperator
{
function getOperatorStrings()
{
return array( ">=" );
}


function getPriority()
{
return XNL_O_PRIORITY_GTEQ;
}

function performOperation( $leftOperand, $rightOperand )
{
if (  $leftOperand >= $rightOperand )
return 1;
return 0;
}
};

class XNL_BinaryGtOperator extends XNL_BinaryOperator
{
function getOperatorStrings()
{
return array( ">" );
}


function getPriority()
{
return XNL_O_PRIORITY_GT;
}

function performOperation( $leftOperand, $rightOperand )
{
if (  $leftOperand > $rightOperand )
return 1;
return 0;
}
};

class XNL_BinaryEqOperator extends XNL_BinaryOperator
{
function getOperatorStrings()
{
return array( "==" );
}

function getPriority()
{
return XNL_O_PRIORITY_EQ;
}

function performOperation( $leftOperand, $rightOperand )
{
if (  $leftOperand == $rightOperand )
return 1;
return 0;
}
};

class XNL_BinaryNeqOperator extends XNL_BinaryOperator
{
function getOperatorStrings()
{
return array( "!=", "<>" );
}

function getPriority()
{
return XNL_O_PRIORITY_NEQ;
}

function performOperation( $leftOperand, $rightOperand )
{
if (  $leftOperand != $rightOperand )
return 1;
return 0;
}
};


class XNL_BinaryModOperator extends XNL_BinaryOperator
{
function getOperatorStrings()
{
return array( "%" );
}

function getPriority()
{
return XNL_O_PRIORITY_MOD;
}

function performOperation( $leftOperand, $rightOperand )
{
return $leftOperand % $rightOperand;
}
};

class XNL_BinaryDivOperator extends XNL_BinaryOperator
{
function getOperatorStrings()
{
return array( "/" );
}

function getPriority()
{
return XNL_O_PRIORITY_ARITH;
}

function performOperation( $leftOperand, $rightOperand )
{
return round($leftOperand / $rightOperand);
}
};


class XNL_BinaryMultOperator extends XNL_BinaryOperator
{
function getOperatorStrings()
{
return array( "*" );
}

function getPriority()
{
return XNL_O_PRIORITY_ARITH;
}

function performOperation( $leftOperand, $rightOperand )
{
return $leftOperand * $rightOperand;
}
};


?>
