<?
/**
 *                                                 
 *                                                                                                       
 *                                                 
 *                                                                       
 */
function cmd_contentrepository_del($id) {
global $TIME, $USER_ID, $ERROR;

if (!$id) halt(7,"cmd_contentrepository_del: No id. id($id)");

$contentrepository = &NodeFactory::getStaticInstanceOf(T_CONTENTREPOSITORY, $id);
$success = $contentrepository->delete();

if (!$success) {
if ($err = $contentrepository->getErrors()) {
foreach ( $err as $field=>$exception ) {
if ( is_array( $exception ) && count( $exception ) > 0 ) {
$ERROR[] = $exception[0]->getMessage();
}
}
}
}

if (!$success) {
return $ERROR[0];
}
}

/**
 *                                               
 *                                                
 */
function cmd_contentrepository_check($id) {
if (!$id) halt(7,"cmd_contentrepository_check: No id. id($id)");
$javaParser =& CodeParser::getJavaParser();
$javaParser->checkContentrepository($id);

$status = "";
$tagmap_valid = check_tagmap_integrity($id, &$status);
$sql = "UPDATE contentrepository SET ".($tagmap_valid ? "" : "checkstatus = 0, ")."checkresult = concat(checkresult, '".sqlslashes($status)."') WHERE id = ".sqlf_tl_num($id);
query($sql);//            
}

/**
 *                                          
 *                                                 
 */
function cmd_contentrepository_repair($id) {
if (!$id) halt(7,"cmd_contentrepository_repair: No id. id($id)");
$javaParser =& CodeParser::getJavaParser();
$javaParser->repairContentrepository($id);

$status = "";
$tagmap_valid = check_tagmap_integrity($id, &$status);
$sql = "UPDATE contentrepository SET ".($tagmap_valid ? "" : "checkstatus = 0, ")."checkresult = concat(checkresult, '".sqlslashes($status)."') WHERE id = ".sqlf_tl_num($id);
query($sql);//            
}

function check_tagmap_integrity($id, &$status) {
$where = "";
//            
 //                                                                                          
 //                                                              
 $sql = "SELECT c1.id AS c1id,c1.tagname AS c1tagname,c1.mapname AS c1mapname,c1.object AS c1object, c2.id AS c2id,c2.object AS c2object,c2.tagname AS c2tagname FROM tagmap AS c1 LEFT JOIN tagmap AS c2 ON c1.contentrepository_id = c2.contentrepository_id AND c1.mapname = c2.mapname AND (c1.optimized != c2.optimized OR c1.attributetype != c2.attributetype OR c1.multivalue != c2.multivalue) WHERE c1.contentrepository_ID = ".sqlf_tl_num($id)." AND (c2.id IS NOT NULL OR (c1.optimized = 1 AND c1.multivalue = 1))";
$rs = query( $sql );//            
 if( count($rs["arr"]) > 0 ) {
$conflicts = "";
while( list( $key, $row ) = each($rs["arr"]) ) {
//            
 if( $where != "" ) {
$where .= ",";
}
$where .= $row["c1id"];
if( $row["c2id"] ) {
$conflicts .= i18n( "Mapname: '{0}' - Tagname '{1}' (Object Type: {2}) conflicts with Tagname '{3}' (Object Type: {4})",0, $row["c1mapname"],$row["c1tagname"],$row["c1object"],$row["c2tagname"],$row["c1object"] );
$conflicts .= "\n";
} else {
$conflicts .= i18n( "Tagname '{0}' is marked as optimized and multivalue at the same time.", 0, $row["c1tagname"] ) . "\n";
}
}
$where = "id IN ( $where )";
$status = "\n\n".i18n( "Tagmap Integrity test failed. {0} Tagmap conflicts found:", 0, count( $rs["arr"] ) )."\n$conflicts\n";
return false;
} else {
//                     
 $status = "\n\n".i18n( "Tagmap Integrity successfully verified." )."\n";
return true;
}
}

function get_linkable_nodes() {
global $USER_ID, $T_DOMAIN;

//              
 $sql = "SELECT n.id, n.folder_id, IF(cr.name IS NOT NULL, CONCAT(f.name, ' > ', cr.name), f.name) name
    FROM node n
    INNER JOIN folder f ON n.folder_id = f.id
    LEFT JOIN contentrepository cr ON n.contentrepository_id = cr.id
    ORDER BY f.name";
$rs = query($sql);//            

$node_infos = array();

//                               
 if ($rs["arr"]) {
while (list($key,$val) = each($rs["arr"])) {
//                          
 if (perm($USER_ID,$T_DOMAIN,$val["folder_id"],0)) {
$node_infos[$val["id"]] = $val["name"];
}
}
}

return $node_infos;
}

function get_linked_nodes($id) {
$nodes = array();
$rs = query("SELECT id FROM node WHERE contentrepository_id = ".sqlf_tl_num($id));//            
 foreach ($rs["arr"] as $row) {
$nodes[] = $row["id"];
}

return $nodes;
}

function cmd_link_nodes($id, $nodes) {
//                                    
 $allowed_nodes = get_linkable_nodes();

//                                                                        
 $new_unlinked = array_diff(array_keys($allowed_nodes), $nodes);

//                                           
 $new_linked = array_intersect(array_keys($allowed_nodes), $nodes);

//                               
 $linked = get_linked_nodes($id);

//                                                  
 $new_linked = array_diff($new_linked, $linked);

//                 

//                   
 if (is_array($new_unlinked) && count($new_unlinked) > 0) {
$sql = "UPDATE node SET contentrepository_id = 0 WHERE contentrepository_id = ".sqlf_tl_num($id)." AND id in (".implode(",", sqlf_tl_num_array($new_unlinked)).")";
query($sql);//            
 }

//                   
 if (is_array($new_linked) && count($new_linked) > 0) {
$sql = "UPDATE node SET contentrepository_id = ".sqlf_tl_num($id)." WHERE id in (".implode(",", sqlf_tl_num_array($new_linked)).")";
query($sql);//            
 }
}

function cmd_unlink_node($cr_id, $node_id) {
global $USER_ID, $T_CONTENT, $T_DOMAIN;
if (!$cr_id || !$node_id) halt(7,"cmd_unlink_node: Invalid cr_id ($cr_id) or node_id ($node_id)");
$foldernode = get_folder_of_node($node_id);

//                                              
 if (!perm($USER_ID, T_CONTENTREPOSITORY, $cr_id, 2) || !perm($USER_ID, $T_CONTENT, 0, 8) || !perm($USER_ID, $T_DOMAIN, $foldernode, 0)) {
return i18n("no permission");
}

//                                           
 $sql = "UPDATE node SET contentrepository_id = 0 WHERE id = ".sqlf_tl_num($node_id)." AND contentrepository_id = ".sqlf_tl_num($cr_id);
query($sql);//            
 //                  

//                                 
 $javaParser =& CodeParser::getJavaParser();
$javaParser->cleanContentrepository($cr_id, $node_id);
}

function cmd_assign_node($cr_id, $node_id) {
global $USER_ID, $T_CONTENT, $T_DOMAIN;
if (!$cr_id || !$node_id) halt(7,"cmd_assign_node: Invalid cr_id ($cr_id) or node_id ($node_id)");
$foldernode = get_folder_of_node($node_id);

//                                              
 if (!perm($USER_ID, T_CONTENTREPOSITORY, $cr_id, 2) || !perm($USER_ID, $T_CONTENT, 0, 8) || !perm($USER_ID, $T_DOMAIN, $foldernode, 0)) {
return i18n("no permission");
}

$sql = "UPDATE node SET contentrepository_id = ".sqlf_tl_num($cr_id)." WHERE id = ".sqlf_tl_num($node_id)." AND (contentrepository_id = 0 or contentrepository_id is null)";
query($sql);//            
 //                  
}

/**
 *                           
 *                                              
 */
function cmd_contentrepository_copy($id) {
$contentrepository = &NodeFactory::getStaticInstanceOf(T_CONTENTREPOSITORY, $id);
if ($contentrepository != null) {
$contentrepository->copyObject();
}
}

/**
 *                                                                       
 */
function cmd_tagmapentry_copy($id, $target_contentrepository_id) {
//                                     
 $sql = "select * from tagmap where id = ".sqlf_tl_num($id);
$rs = query($sql);//            
 $entry = $rs['arr'][0];

$sql = "select id,tagname,mapname from tagmap where contentrepository_id = ".sqlf_tl_num($target_contentrepository_id)." and mapname = '".sqlslashes($entry['mapname'])."' and object = ".sqlf_tl_num($entry['object']);
$rs = query($sql);//            
 foreach($rs['arr'] as $row) {
logcmd(W_DEL, T_CONTENTREPOSITORY, $row['id'], 0,
"deleted conflicting tagmap entry mapname:" . $row['mapname'] . ",tagname:" . $row['tagname'] . ",object:" . $row['object']);
$sql = "delete from tagmap where id = ".sqlf_tl_num($row['id']);
query($sql);//            
 }

$cols = '';
$values = '';
foreach($entry as $key => $val) {
if (is_int($key)) {
continue;
}
if ($key == 'id') {
continue;
}
if ($key == 'contentrepository_id') {
$val = $target_contentrepository_id;
}
if ($cols) {
$cols .= ',';
$values .= ',';
}
$cols .= sqlf_tl_num($key);
$values .= "'".sqlslashes($val)."'";
}
$sql = "insert into tagmap ($cols) values ($values)";
$rs = query($sql);//            
 logcmd(W_COPY, T_CONTENTREPOSITORY, $entry['id'], $rs['iid'], "Copied tagmapentry with mapname {".$entry['mapname']."}");
}

?>
